Status: Closed

Priority: Severe/Regression
Affected QGIS version:master Regression?:

Operating System: Easy fix?:

Pull Request or Patch supplied:No Resolution: fixed

Crashes QGIS or corrupts data:No Copied to github as #: 16043

Description

pick the attached shape, then select the polygon with attribute "cat = 36" and try the tool, it will say it can't do the operation.

The shape seems to have no errors, and if imported into postgis then the tool will work as expected.

Associated revisions

Revision aef3f345 - 2013-01-03 09:29 AM - Bernhard Ströbl

fix #6925

fTools' eliminate now works if the polygon to merge with has an id of 0

Revision 71580df3 - 2013-01-03 10:30 PM - Werner Macho

Merge pull request #371 from bstroebl/fix#6925

fix #6925 fTools eliminate now works if the polygon to merge with has an id of 0

History

#1 - 2013-01-03 12:36 AM - Bernhard Ströbl

I made a pull request that fixes the case that the polygon to merge with has id=0: https://github.com/qgis/Quantum-GIS/pull/371

#2 - 2013-01-03 01:31 PM - Werner Macho

- Status changed from Open to Closed

Fixed in changeset commit:"71580df366401df4bee9942c099f541796ed90f3".

#3 - 2013-01-17 09:20 AM - Giovanni Manghi

- File lixo.zip added

- Status changed from Closed to Reopened

- File result.jpg added

- File castqgis.ogg added
https://github.com/qgis/Quantum-GIS/pull/371


Hi Bernhard,

I just noticed that seems the last fixed caused a pretty bad regression in the tool.

Add the attached sample shape and then make a selection using this expression (or even a simpler one):

("USO_SOLO" = 'LE') OR ("USO_SOLO"='PEDR')OR ("USO_SOLO" = 'LAV') OR ("USO_SOLO"='MATOS') OR ("USO_SOLO"='SEBE_ARV') OR

("USO_SOLO"='ETB')  OR ("USO_SOLO"='LA') OR ("USO_SOLO"='LA_GR') OR ("USO_SOLO"='EA') OR ("USO_SOLO"='AUTOESTRADA')

then run the tool.

The result (attached screenshot) is a shape where many polygons where lost, and if you give the vector a little transparency you'll see that a few polygons

are now duplicated.

Moreover in the result there are strange "structures" that when edited are revealed as tringular flattened holes (notice that the input layer is topologically

correct, it has been checked with GRASS, so such "structures" are really not expected). See attached screencast.

Note:

the tool before the last fix does not produce such missing/duplicated polygons, but also does not produce the right result (with the above selection).

#4 - 2013-01-17 09:21 AM - Giovanni Manghi

- Subject changed from Eliminate slivers polygon tool fail to remove a particular polygon to Eliminate slivers polygon creates wrong output

#5 - 2013-01-18 01:16 AM - Bernhard Ströbl

Giovanni,

thanks for thorough testing!

I even get the wrong result when undoing the last fix. So the good message: it is not a regression :-)

#6 - 2013-01-18 01:52 AM - Giovanni Manghi

thanks for thorough testing!

you welcome! but this is a so useful tool that it is not easy NOT test it :)

I even get the wrong result when undoing the last fix.

do you mean the missing/duplicated polygon?

I don't, but instead the attributes of the result layer are mixed up, so it is still wrong, but just on the attributes side.

#7 - 2013-01-18 01:57 AM - Bernhard Ströbl

Giovanni Manghi wrote:

do you mean the missing/duplicated polygon?
I don't, but instead the attributes of the result layer are mixed up, so it is still wrong, but just on the attributes side.

I mean my result looks the very same using current master and undoing my fix in current master. Are you on current master? Did not check attributes,

though.

#8 - 2013-01-21 07:47 AM - Bernhard Ströbl

Giovanni,

I redid my code, and issued a pull request containing the changes. Give it a try with your data.

During my analysis I discovered your data are not really topologically correct: Adjacent polygons do not always share the same nodes, some nodes are

missing in one of the two polygons. This results in useless line fragments within polygons after running eliminate. I fixed your data by running v.clean

tool=break in GRASS.

#9 - 2013-01-22 12:35 AM - Alexander Bruy

- Status changed from Reopened to Closed

Fixed in changeset commit:"07772f13f6ac102dd18eccf68d350f6bafeef4c8".

#10 - 2013-01-22 12:37 AM - Alexander Bruy

- Resolution set to fixed

#11 - 2013-01-22 07:50 AM - Giovanni Manghi

Bernhard Ströbl wrote:

Giovanni,

I redid my code, and issued a pull request containing the changes. Give it a try with your data.

During my analysis I discovered your data are not really topologically correct: Adjacent polygons do not always share the same nodes, some nodes

are missing in one of the two polygons. This results in useless line fragments within polygons after running eliminate. I fixed your data by running 

v.clean tool=break in GRASS.

Thanks!

well... if it wasn't clean (then I missed something when using grass) then the "strange" results are understandable.

After rewriting the tool code does it works with the provided sample? I'm asking just because I'm with of lack of time to test in there days.

cheers!

#12 - 2013-01-22 07:59 AM - Bernhard Ströbl

- File elim.zip added

Giovanni Manghi wrote:
well... if it wasn't clean (then I missed something when using grass) then the "strange" results are understandable.

No, the strange results (holes and overlaps) where caused by the code. I have described all that was caused by the data not being clean in message 8

above

Giovanni Manghi wrote:

After rewriting the tool code does it works with the provided sample? I'm asking just because I'm with of lack of time to test in there days.

It worked with the sample data. I attached the resulting shape file.

#13 - 2017-05-01 01:22 AM - Giovanni Manghi

The "ftools" category is being removed from the tracker, changing the category of this ticket to "Processing/QGIS" to not leave the category orphaned.

Files

onequestiononyournewplugin.zip 50 KB 2012-12-28 Giovanni Manghi

lixo.zip 212 KB 2013-01-17 Giovanni Manghi

result.jpg 47.3 KB 2013-01-17 Giovanni Manghi

castqgis.ogg 3.41 MB 2013-01-17 Giovanni Manghi

elim.zip 419 KB 2013-01-22 Bernhard Ströbl

2025-04-26 4/4


